<template>
	<vue3-chart-js ref="chartRef"
		:type="type"
		:data="chartJsData" 
		:options="options"  /> 
</template>
<script>
import { ref, onMounted, computed } from 'vue';
import vue3ChartJs from "@j-t-mcc/vue3-chartjs";

export default {
	name: "mind-widget-chart",
	components: {
		vue3ChartJs
	},
	props: {
		type: String,
		options: [Object],

		/**
		 * contiene los datos utilizados para dibujar el chart
		 * 
		 */
		data: [Object, Array],

		/**
		 * Indica que los elementos del chart (labels, valores, y datasets) se generan dinámicamente utilizando los parámetros
		 * item-label, item-value e item-dataset
		 */
		dynamicData: Boolean,

		/**
		 * nombre del campo que se utilizará para completar el eje x del gráfico
		 */
		itemLabel: String,
		
		/**
		 * nombre del campo que se utilizará para completar el eje y del gráfico
		 * los formatos permitidos son:
		 *  + string: por ej "cantidad"
		 *  + array de strings: ["costo", "venta"]
		 *  + array de objetos: [{campo1: "Etiqueta 1"}, {campo2: "Etiqueta 2"}]
		 * Notas
		 *  + cuando se proporciona un array, el widget arma un dataset por cada elemento del array
		 *  + cuando se proporciona un array de objetos, se el objeto debe tener el formato {campo: "etiqueta"}
		 */
		itemValue: [String, Array, Object],

		/**
		 * si se especifica este parámetro. se generará un data set por cada nuevo valor en el campo indicado
		 * por ejemplo, si se indica `item-dataset="año"` se generará un nuevo dataset por cada año
		 * Notas: 
		 *  + esta propiedad no es compatible con item-value=Array
		 *  + si itemValue es un array de elementos, se generará un dataset conlos valores de itemValue
		 */
		itemDataset: String,

		sortLabels: Boolean,

		backgroundColors: {
			type: [Array, Object],
			default: () => []
		}

	},
	setup(props) {	
		const chartRef = ref(null)
		const chartJsData = ref({
			labels:[],
			datasets:[],
		})

		//Lista Autogenerada de Labels
		const Labels = computed(()=>{
			if(!props.itemLabel) {
				return []
			}
			const l = []
			for (const d of props.data) {
				if(d){
					l.push(d[props.itemLabel])
				}
			}

			// if(props.sortLabels) {
			// 	l.sort()
			// }

			return [...new Set(l)];
		})

		/**
		 * devuelve la lista de valores (y) agrupados por dataset
		 *  + el resultado es un array de objetos, 
		 *  + cada objeto es un dataset, que contiene el label y data
		 *  + data es un array de objetos con el formato {x: label, y: valor}
		 */
		const valuesAsCoords = computed(() => {
			const res = {}
			const itemValues = Array.isArray(props.itemValue) ? props.itemValue : [props.itemValue ]
			if(!props.dynamicData) { 
				return null
			}
			for (const d of props.data) {
				if(!d){continue}
				for(const i of itemValues) {
					let  c = i, l = i

					if(typeof(i) == "object") {
						c = Object.keys(i)[0]
						l = i[c]
					}
					const x = d[props.itemLabel]
					const y = d[c]


					if(props.itemDataset) {
						l = d[props.itemDataset]
					} 
					if(!res[l]) {
						res[l] = []
					}
					res[l].push({x, y})
				}
			}
			return res
		})

		const valuesAsArray = computed(() => {
			if(!props.dynamicData) { 
				return null
			}
			let v = []
			for (const d of props.data) {
				if(d){
					v.push(d[props.itemValue])

				}
			}
			return v
		})

		/**
		 * Devuelve un array de colores, basado en la propiedad  backgroundColors y en los labels
		 * Esta funcion es utilizada por 
		 */
		function getColors() {
			if(Array.isArray(props.backgroundColors)) {
				return 
			}
			const colors = []
			Labels.value.forEach((l)=>{
				colors.push(props.backgroundColors[l] || '#9ea2a660')	
			})
			return colors
		}


		/**
		 * devuelve los datasets generados automáticamente
		 */
		const datasets = computed(() => {
			if(!props.dynamicData) { 
				return []
			}
			const ds = []
			let i = 0
			switch(props.type) {
				case 'line':
				case "bar":
				case "scatter":
					for(let k  of Object.keys(valuesAsCoords.value)) {

						const v = valuesAsCoords.value[k]
						let hidden = false
						// if(this.options.defaultVisibleDatasets ) {
						// 	let found = this.options.defaultVisibleDatasets.find(d => d == k)
						// 	hidden = !found
						// }
						ds.push({
							hidden: hidden,
							label: k,
							data: v,
							// fill: true,
							backgroundColor: Array.isArray(props.backgroundColors) ? props.backgroundColors[i] : props.backgroundColors[k],
							// borderColor: coloresBorde.shift(),
							borderWidth: 2,
						})
						i++;
					}
					break;
				case "pie":
				case "doughnut":
				case "radar":
				case "polarArea":
					ds.push({
						data: valuesAsArray.value,
						backgroundColor: getColors,
							// borderColor: coloresBorde.shift(),
					})
					break;
			}

			return ds
		})



		function update() {
			chartJsData.value.labels = props.dynamicData ? Labels.value : props.data.labels
			chartJsData.value.datasets = props.dynamicData ? datasets.value : props.data.datasets


			chartRef.value.update()
		}

		function toBase64Image(type, quality) {
			return chartRef.value.chartJSState.chart.toBase64Image(type, quality)
		}

		function getCanvasSize() {
			// const ctx = chartRef.value.getContext("2d")
			const {width, height} = chartRef.value.chartJSState.chart

			return  {width, height}
		}

    onMounted(() => {
			update()
    });

		return {		
			chartRef,
			chartJsData,
			update,	
			Labels,
			valuesAsCoords,
			valuesAsArray,
			datasets,
			toBase64Image,
			getCanvasSize,
		}
	},
}
</script>


